/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.persistence.api;

import java.util.List;
import java.util.Map;

import com.adaptrex.core.ext.Filter;
import com.adaptrex.core.ext.Sorter;


public interface ORMStoreData {

	public List<Map<String, Object>> getData();
	public Integer 				getTotalCount();
	
	public void 				setStart(Integer start);
	public void 				setLimit(Integer limit);
	public void 				setGroupers(List<Sorter> groupers);
	public void 				setSorters(List<Sorter> sorters);
	public void 				setWhere(String where);
	public void 				setParams(Map<String,Object> params);
	public void 				setFilters(List<Filter> filters);
	public Integer 				getStart();
	public Integer 				getLimit();
	public List<Sorter> 		getGroupers();
	public List<Sorter> 		getSorters();
	public String 				getWhere();
	public Map<String, Object>	getParams();
	public List<Filter> 		getFilters();
	public void 				setTotalCount(Integer totalCount);
}
