/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.view;

import com.adaptrex.core.AdaptrexConfig;
import com.adaptrex.core.AdaptrexRegistry;

public class BootstrapComponent {

	private String extBuild;
	
	public BootstrapComponent() {
		this(null);
	};
	
	public BootstrapComponent(String extBuild) {
		this.extBuild = extBuild != null ? extBuild :
			AdaptrexRegistry.getConfig().get(AdaptrexConfig.EXT_BUILD, "production");
	};
	
	public String toString() {
		return "<script type='text/javascript' src='app" + 
				(this.extBuild.equals("production") ? "-all" : "") + 
				".js'></script>\n";
	}

	public void setExtBuild(String extBuild) {
		this.extBuild = extBuild;
	}
}
