package com.adaptrex.core.view.tapestry.components;

import javax.servlet.http.HttpServletRequest;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.RequestGlobals;

import com.adaptrex.core.view.ConfigComponent;

public class Config {

	@Inject	private RequestGlobals requestGlobals;
	
	@Parameter @Property private String ns;
	@Parameter @Property private String namespace;
	
	@Parameter @Property private String weblib;
	@Parameter @Property private String ext_version;
	@Parameter @Property private String ext_build;
	@Parameter @Property private String ext_path;
	@Parameter @Property private String ext_theme;
	@Parameter @Property private String senchatouch_version;
	@Parameter @Property private String senchatouch_path;
	@Parameter @Property private String senchatouch;
	
	public String getBody() {
		HttpServletRequest request = requestGlobals.getHTTPServletRequest();
		
		if (ns == null) ns = namespace;
		
		ConfigComponent configComponent = new ConfigComponent(request, ns);
		
		if (weblib != null)			configComponent.setWeblibPath(weblib);
		if (ext_version != null)	configComponent.setExtVersion(ext_version);
		if (ext_build != null)		configComponent.setExtBuild(ext_build);
		if (ext_path != null)		configComponent.setExtPath(ext_path);
		if (ext_theme != null)		configComponent.setExtTheme(ext_theme);
		
		if (senchatouch_version != null)	configComponent.setSenchaTouchVersion(senchatouch_version);
		if (senchatouch_path != null)		configComponent.setSenchaTouchPath(senchatouch_path);
		if (senchatouch != null) 			configComponent.setTouch(getBoolean(senchatouch));
		
		return configComponent.toString();
	}
	
	private Boolean getBoolean(Object param) {
		if (param.getClass().equals(String.class)) {
			param = Boolean.valueOf(String.valueOf(param));
		}
		return (Boolean) param;
	}
}
